---
title: Get Account Billing History
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/python)

[Billing](https://developers.cloudflare.com/api/python/resources/billing)

[History](https://developers.cloudflare.com/api/python/resources/billing/subresources/history)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Get Account Billing History

billing.history.list(HistoryListParams\*\*kwargs) -> SyncV4PagePaginationArray\[[HistoryListResponse](<https://developers.cloudflare.com/api/python/resources/billing#(resource)%20billing.history%20%3E%20(model)%20history_list_response%20%3E%20(schema)>)]

GET/accounts/{account\_id}/billing/history

Gets the billing history for an account.

##### Security

<details>

<summary>API Token</summary>



The preferred authorization scheme for interacting with the Cloudflare API. <a href="https://developers.cloudflare.com/fundamentals/api/get-started/create-token/">Create a token</a>.

**Example:**<code>Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### Accepted Permissions (at least one required)

`Billing Write``Billing Read`

##### ParametersExpand Collapse

account\_id: str

Identifier

maxLength32

[Link to this property](<#(resource)%20billing.history%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20account_id%20%3E%20(schema)>)

page: Optional\[int]

Page number of paginated results.

minimum1

[Link to this property](<#(resource)%20billing.history%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20page%20%3E%20(schema)>)

per\_page: Optional\[int]

Number of items per page.

minimum1

[Link to this property](<#(resource)%20billing.history%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20per_page%20%3E%20(schema)>)

status: Optional\[str]

Filter billing history by status.

[Link to this property](<#(resource)%20billing.history%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20status%20%3E%20(schema)>)

##### ReturnsExpand Collapse

<details>

<summary>

class HistoryListResponse: …

</summary>

id: Optional\[str]

Billing history item identifier.

<a href="#(resource)%20billing.history%20%3E%20(model)%20history_list_response%20%3E%20(schema)%20%3E%20(property)%20id">Link to this property</a>

action: Optional\[str]

The billing item action.

<a href="#(resource)%20billing.history%20%3E%20(model)%20history_list_response%20%3E%20(schema)%20%3E%20(property)%20action">Link to this property</a>

amount: Optional\[float]

The amount associated with this billing item.

<a href="#(resource)%20billing.history%20%3E%20(model)%20history_list_response%20%3E%20(schema)%20%3E%20(property)%20amount">Link to this property</a>

amount\_to\_pay: Optional\[float]

The amount remaining to pay.

<a href="#(resource)%20billing.history%20%3E%20(model)%20history_list_response%20%3E%20(schema)%20%3E%20(property)%20amount_to_pay">Link to this property</a>

currency: Optional\[str]

The currency of the billing item.

<a href="#(resource)%20billing.history%20%3E%20(model)%20history_list_response%20%3E%20(schema)%20%3E%20(property)%20currency">Link to this property</a>

description: Optional\[str]

The billing item description.

<a href="#(resource)%20billing.history%20%3E%20(model)%20history_list_response%20%3E%20(schema)%20%3E%20(property)%20description">Link to this property</a>

external\_invoice\_id: Optional\[str]

The external invoice identifier.

<a href="#(resource)%20billing.history%20%3E%20(model)%20history_list_response%20%3E%20(schema)%20%3E%20(property)%20external_invoice_id">Link to this property</a>

hosted\_invoice\_url: Optional\[str]

URL to the hosted invoice.

<a href="#(resource)%20billing.history%20%3E%20(model)%20history_list_response%20%3E%20(schema)%20%3E%20(property)%20hosted_invoice_url">Link to this property</a>

invoice\_id: Optional\[str]

The associated invoice identifier.

<a href="#(resource)%20billing.history%20%3E%20(model)%20history_list_response%20%3E%20(schema)%20%3E%20(property)%20invoice_id">Link to this property</a>

occurred\_at: Optional\[datetime]

When the billing event occurred.

formatdate-time

<a href="#(resource)%20billing.history%20%3E%20(model)%20history_list_response%20%3E%20(schema)%20%3E%20(property)%20occurred_at">Link to this property</a>

receipt\_id: Optional\[str]

The associated receipt identifier.

<a href="#(resource)%20billing.history%20%3E%20(model)%20history_list_response%20%3E%20(schema)%20%3E%20(property)%20receipt_id">Link to this property</a>

source: Optional\[str]

The source of the billing item.

<a href="#(resource)%20billing.history%20%3E%20(model)%20history_list_response%20%3E%20(schema)%20%3E%20(property)%20source">Link to this property</a>

source\_invoice\_id: Optional\[str]

The source invoice identifier.

<a href="#(resource)%20billing.history%20%3E%20(model)%20history_list_response%20%3E%20(schema)%20%3E%20(property)%20source_invoice_id">Link to this property</a>

status: Optional\[str]

The status of the billing item.

<a href="#(resource)%20billing.history%20%3E%20(model)%20history_list_response%20%3E%20(schema)%20%3E%20(property)%20status">Link to this property</a>

type: Optional\[str]

The billing item type.

<a href="#(resource)%20billing.history%20%3E%20(model)%20history_list_response%20%3E%20(schema)%20%3E%20(property)%20type">Link to this property</a>

</details>

[Link to this property](<#(resource)%20billing.history%20%3E%20(model)%20history_list_response%20%3E%20(schema)>)

### Get Account Billing History

Python

HTTPTypeScriptPythonGoTerraform

```
import os
from cloudflare import Cloudflare

client = Cloudflare(
    api_token=os.environ.get("CLOUDFLARE_API_TOKEN"),  # This is the default and can be omitted
)
page = client.billing.history.list(
    account_id="023e105f4ecef8ad9ca31a8372d0c353",
)
page = page.result[0]
print(page.id)
```

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": [
    {
      "id": "b69a9f3492637782896352daae219e7d",
      "action": "subscription",
      "amount": 20.99,
      "amount_to_pay": 0,
      "currency": "USD",
      "description": "The billing item description",
      "external_invoice_id": "external_invoice_id",
      "hosted_invoice_url": "hosted_invoice_url",
      "invoice_id": "invoice_id",
      "occurred_at": "2014-03-01T12:21:59.3456Z",
      "receipt_id": "receipt_id",
      "source": "source",
      "source_invoice_id": "source_invoice_id",
      "status": "status",
      "type": "charge"
    }
  ],
  "success": true,
  "result_info": {
    "count": 1,
    "page": 1,
    "per_page": 20,
    "total_count": 2000
  }
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": [
    {
      "id": "b69a9f3492637782896352daae219e7d",
      "action": "subscription",
      "amount": 20.99,
      "amount_to_pay": 0,
      "currency": "USD",
      "description": "The billing item description",
      "external_invoice_id": "external_invoice_id",
      "hosted_invoice_url": "hosted_invoice_url",
      "invoice_id": "invoice_id",
      "occurred_at": "2014-03-01T12:21:59.3456Z",
      "receipt_id": "receipt_id",
      "source": "source",
      "source_invoice_id": "source_invoice_id",
      "status": "status",
      "type": "charge"
    }
  ],
  "success": true,
  "result_info": {
    "count": 1,
    "page": 1,
    "per_page": 20,
    "total_count": 2000
  }
}
```